"use strict";

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var findBabelConfig = require('find-babel-config');

var path = require('path');

var fs = require('fs');

var checkIgnoreDepth = require('../helpers/check-ignore-depth'); //------------------------------------------------------------------------------
// Rule Definition
//------------------------------------------------------------------------------


var values = Object.values || function (obj) {
  return Object.keys(obj).map(function (e) {
    return obj[e];
  });
};

module.exports = {
  meta: {
    docs: {
      description: 'Warn when using relative paths to modules aliased',
      category: 'Fill me in',
      recommended: false
    },
    fixable: null,
    // or "code" or "whitespace"
    schema: [{
      type: 'object',
      properties: {
        ignoreDepth: {
          type: 'number'
        }
      },
      additionalProperties: false
    }]
  },
  create: function create(context) {
    var _findBabelConfig$sync = findBabelConfig.sync('.'),
        config = _findBabelConfig$sync.config;

    var options = context.options; // try/catch
    // handle name collision with package.json

    var validPluginNames = new Set(['babel-plugin-module-resolver', 'module-resolver']);

    var _config$plugins$filte = config.plugins.filter(function (plugins) {
      if (Array.isArray(plugins) && validPluginNames.has(plugins[0])) {
        return plugins;
      }
    }),
        _config$plugins$filte2 = _slicedToArray(_config$plugins$filte, 1),
        moduleResolver = _config$plugins$filte2[0];

    var _moduleResolver$ = moduleResolver[1],
        _moduleResolver$$alia = _moduleResolver$.alias,
        alias = _moduleResolver$$alia === void 0 ? {} : _moduleResolver$$alia,
        root = _moduleResolver$.root;
    var normalizedAliasArray = values(alias).map(function (a) {
      return path.join(process.cwd(), a);
    });

    var hasError = function hasError(val) {
      if (!val) return; // template literals will have undefined val

      if (options && options.length) {
        var _options = _slicedToArray(options, 1),
            first = _options[0];

        var ignoreDepth = first.ignoreDepth;
        var ignorePrefix = Array(ignoreDepth).fill('../').join('');
        if (checkIgnoreDepth({
          ignorePrefix: ignorePrefix,
          path: val
        })) return;
      }

      var filename = context.getFilename();
      var filePath = path.dirname(filename);
      var resolvedPath = path.resolve(filePath, val);
      var resolvedExt = path.extname(val) ? '' : '.js';
      var pathExists = fs.existsSync("".concat(resolvedPath).concat(resolvedExt)) || fs.existsSync("".concat(resolvedPath, "/index.js"));
      var isAliased = normalizedAliasArray.some(function (v) {
        return resolvedPath.includes(v);
      });
      return isAliased && pathExists && val.match(/\.\.\//); // matches, exists, and starts with ../
    };

    return {
      ImportDeclaration: function ImportDeclaration(node) {
        if (hasError(node.source.value)) {
          context.report({
            node: node,
            message: 'Do not use relative path for aliased modules',
            loc: node.source.loc
          });
        }
      },
      CallExpression: function CallExpression(node) {
        var val = node.callee.name || node.callee.type;

        if (val === 'Import' || val === 'require') {
          hasError(node.arguments[0].value) && context.report({
            node: node,
            message: 'Do not use relative path for aliased modules',
            loc: node.arguments[0].loc
          });
        }
      }
    };
  }
};